## dde-shell 1.99.36

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(DS_VERSION "1.99.0" CACHE STRING "Define project version")
project(DDEShell
    VERSION "${DS_VERSION}"
    DESCRIPTION "dde-shell"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dde-shell"
    LANGUAGES CXX C
)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
option(BUILD_WITH_X11 "Build X11 emulation" ON)

set(DS_BUILD_WITH_QT6 ON CACHE BOOL "Build dde-shell with Qt6")

if (DS_BUILD_WITH_QT6)
    set(QT_VERSION_MAJOR 6)
    set(DTK_VERSION_MAJOR 6)
else()
    set(QT_VERSION_MAJOR 5)
    set(DTK_VERSION_MAJOR "")
endif()

include(CTest)
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}" CACHE STRING "Library install path")
set(DDE_SHELL_PACKAGE_INSTALL_DIR ${CMAKE_INSTALL_DATADIR}/dde-shell CACHE STRING "Package install path")
set(DDE_SHELL_PLUGIN_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/dde-shell CACHE STRING "Plugin install path")
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dde-shell" CACHE STRING "Headers install path")
set(CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/DDEShell" CACHE STRING "CMake config file install directory")
set(QML_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml" CACHE STRING "Qml plugin install directory")
set(DDE_SHELL_TRANSLATION_INSTALL_DIR "${CMAKE_INSTALL_DATADIR}/dde-shell" CACHE STRING "Translation install directory")

find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH};${PROJECT_SOURCE_DIR}/cmake")
include(DDEShellPackageMacros)
include(KDEClangFormat)
include(KDEGitCommitHooks)

find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Concurrent Quick WaylandClient DBus LinguistTools Sql)
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui)
find_package(WaylandProtocols REQUIRED)
find_package(PkgConfig REQUIRED)

add_subdirectory(frame)
add_subdirectory(shell)
add_subdirectory(example)
add_subdirectory(panels)
add_subdirectory(applets)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif(BUILD_TESTING)

configure_package_config_file(
    "${CMAKE_CURRENT_LIST_DIR}/misc/DDEShellConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/DDEShellConfig.cmake"
    INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DDEShellConfigVersion.cmake"
    VERSION ${VERSION}
    COMPATIBILITY SameMajorVersion
)
# Install cmake config file
install(FILES "${PROJECT_SOURCE_DIR}/cmake/DDEShellPackageMacros.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/DDEShellConfig.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/DDEShellConfigVersion.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")

# add clang-format target for all our real source files
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== frame/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0
set(PUBLIC_HEADERS
    dsglobal.h
    dstypes.h
    pluginmetadata.h
    pluginloader.h
    pluginfactory.h
    applet.h
    appletdata.h
    containment.h
    panel.h
    appletproxy.h
    appletbridge.h
    qmlengine.h
    layershell/dlayershellwindow.h
    models/listtotableproxymodel.h
    dsutility.h
)

set(PRIVATE_HEADERS
    private/applet_p.h
    private/containment_p.h
    private/panel_p.h
    private/appletitem_p.h
    private/appletproxy_p.h
    private/appletbridge_p.h
    private/dsqmlglobal_p.h
    layershell/qwaylandlayershellsurface_p.h
    layershell/qwaylandlayershellintegration_p.h
    models/kextracolumnsproxymodel.h
    quick/dsquickdrag_p.h
)
set(PRIVATE_SOURCES "")
if (BUILD_WITH_X11)
    list(APPEND PRIVATE_HEADERS
        private/utility_x11_p.h
    )
    list(APPEND PRIVATE_SOURCES
        utility_x11.cpp
    )
endif(BUILD_WITH_X11)

add_library(dde-shell-frame SHARED
    ${PUBLIC_HEADERS}
    ${PRIVATE_HEADERS}
    ${PRIVATE_SOURCES}
    appletitem.h
    containmentitem.h
    dstypes.cpp
    appletdata.cpp
    pluginmetadata.cpp
    pluginloader.cpp
    pluginfactory.cpp
    applet.cpp
    containment.cpp
    panel.cpp
    appletproxy.cpp
    appletbridge.cpp
    appletitem.cpp
    containmentitem.cpp
    qmlengine.cpp
    appletitemmodel.h
    appletitemmodel.cpp
    dsqmlglobal.cpp
    layershell/dlayershellwindow.cpp
    layershell/qwaylandlayershellsurface.cpp
    layershell/qwaylandlayershellintegration.cpp
    models/kextracolumnsproxymodel.cpp
    models/listtotableproxymodel.cpp
    quick/dsquickdrag.cpp
    popupwindow.h
    popupwindow.cpp
    ddeshell_qml.qrc
    dsutility.cpp
)

set_target_properties(dde-shell-frame PROPERTIES
    PUBLIC_HEADER "${PUBLIC_HEADERS}"
)

qt_generate_wayland_protocol_client_sources(dde-shell-frame FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/layershell/protocol/wlr-layer-shell-unstable-v1.xml
    ${WaylandProtocols_DATADIR}/stable/xdg-shell/xdg-shell.xml
)

set_target_properties(dde-shell-frame PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    OUTPUT_NAME dde-shell
    EXPORT_NAME Shell
)

target_link_libraries(dde-shell-frame
PUBLIC
    Dtk${DTK_VERSION_MAJOR}::Core
    Dtk${DTK_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Quick
PRIVATE
    Qt${QT_VERSION_MAJOR}::QuickPrivate
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::GuiPrivate
    Qt${QT_VERSION_MAJOR}::WaylandClientPrivate
)
target_include_directories(dde-shell-frame INTERFACE
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)
target_link_directories(dde-shell-frame INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${LIB_INSTALL_DIR}>
)

if (BUILD_WITH_X11)
    target_compile_definitions(dde-shell-frame PRIVATE BUILD_WITH_X11)
    pkg_check_modules(XCB REQUIRED IMPORTED_TARGET xcb-ewmh xtst x11)
    target_sources(dde-shell-frame PRIVATE layershell/x11dlayershellemulation.h layershell/x11dlayershellemulation.cpp)
    target_link_libraries(dde-shell-frame PRIVATE PkgConfig::XCB)
endif(BUILD_WITH_X11)

target_compile_definitions(dde-shell-frame
INTERFACE
    DDE_SHELL_PACKAGE_PATH_SUBPATH="dde-shell"
PRIVATE
    DDE_SHELL_QML_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}/${QML_INSTALL_DIR}"
    DDE_SHELL_PLUGIN_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}/${DDE_SHELL_PLUGIN_INSTALL_DIR}"
    DS_LIB
)

install(TARGETS dde-shell-frame EXPORT DDEShellTargets DESTINATION "${LIB_INSTALL_DIR}" PUBLIC_HEADER DESTINATION "${INCLUDE_INSTALL_DIR}")
install(EXPORT DDEShellTargets NAMESPACE Dde:: FILE DDEShellTargets.cmake DESTINATION "${CONFIG_INSTALL_DIR}")

add_subdirectory(plugin)

=== panels/notification/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_library(ds-notification SHARED
    notificationcontainment.h
    notificationcontainment.cpp
)

target_link_libraries(ds-notification PRIVATE
    dde-shell-frame
)

add_library(ds-notification-shared SHARED
    ${CMAKE_SOURCE_DIR}/panels/notification/common/notifyentity.h
    ${CMAKE_SOURCE_DIR}/panels/notification/common/notifyentity.cpp
    ${CMAKE_SOURCE_DIR}/panels/notification/common/dataaccessorproxy.h
    ${CMAKE_SOURCE_DIR}/panels/notification/common/dataaccessorproxy.cpp
    ${CMAKE_SOURCE_DIR}/panels/notification/common/memoryaccessor.h
    ${CMAKE_SOURCE_DIR}/panels/notification/common/memoryaccessor.cpp
    ${CMAKE_SOURCE_DIR}/panels/notification/common/dbaccessor.h
    ${CMAKE_SOURCE_DIR}/panels/notification/common/dbaccessor.cpp
    ${CMAKE_SOURCE_DIR}/panels/notification/common/notifysetting.h
    ${CMAKE_SOURCE_DIR}/panels/notification/common/notifysetting.cpp
)

set_target_properties(ds-notification-shared PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
)
target_include_directories(ds-notification-shared PUBLIC
    ${CMAKE_SOURCE_DIR}/panels/notification/common
)
target_link_libraries(ds-notification-shared PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Sql
    Dtk${DTK_VERSION_MAJOR}::Core
)

install(TARGETS ds-notification-shared DESTINATION "${LIB_INSTALL_DIR}")
ds_install_package(PACKAGE org.deepin.ds.notification TARGET ds-notification)

add_subdirectory(plugin)
add_subdirectory(bubble)
add_subdirectory(center)
add_subdirectory(osd)
add_subdirectory(server)

=== panels/dock/taskmanager/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS DBus WaylandClient)
find_package(yaml-cpp REQUIRED)
find_package(TreelandProtocols REQUIRED)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ApplicationManager1.Application.xml
    PROPERTIES  INCLUDE api/types/am.h
                CLASSNAME Application
)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ApplicationManager1.xml
    PROPERTIES  INCLUDE api/types/am.h
                CLASSNAME ApplicationManager
)

set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ObjectManager1.xml
    PROPERTIES  INCLUDE api/types/am.h
                CLASSNAME ObjectManager
)

qt_add_dbus_interfaces(
    DBUS_INTERFACES
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ApplicationManager1.Application.xml
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ApplicationManager1.xml
    ${CMAKE_CURRENT_SOURCE_DIR}/api/amdbus/org.desktopspec.ObjectManager1.xml
)

qt_add_dbus_adaptor(DBUS_INTERFACES
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.deepin.ds.dock.taskmanager.item.xml
    appitem.h
    dock::AbstractItem
    itemadaptor
    ItemAdaptor
)

qt_add_dbus_adaptor(DBUS_INTERFACES
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.deepin.ds.dock.taskmanager.xml
    taskmanager.h
    dock::TaskManager
    taskmanageradaptor
    TaskManagerAdaptor
)

add_library(dock-taskmanager SHARED ${DBUS_INTERFACES}
    abstractwindow.h
    abstractwindowmonitor.cpp
    abstractwindowmonitor.h
    abstractitem.h
    abstractitem.cpp
    appitem.cpp
    appitem.h
    rolecombinemodel.cpp
    rolecombinemodel.h
    rolegroupmodel.cpp
    rolegroupmodel.h
    itemmodel.cpp
    itemmodel.h
    desktopfileabstractparser.cpp
    desktopfileabstractparser.h
    desktopfileamparser.cpp
    desktopfileamparser.h
    desktopfileparserfactory.h
    taskmanager.cpp
    taskmanager.h
    treelandwindow.cpp
    treelandwindow.h
    treelandwindowmonitor.cpp
    treelandwindowmonitor.h
    taskmanagersettings.cpp
    taskmanagersettings.h
)

qt_generate_wayland_protocol_client_sources(dock-taskmanager
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-foreign-toplevel-manager-v1.xml
        ${WaylandProtocols_DATADIR}/staging/ext-foreign-toplevel-list/ext-foreign-toplevel-list-v1.xml
)

target_link_libraries(dock-taskmanager PRIVATE
    dde-shell-frame
    Qt${QT_VERSION_MAJOR}::WaylandClientPrivate
    Qt${QT_VERSION_MAJOR}::Concurrent
    yaml-cpp
    PkgConfig::WaylandClient
)

if (BUILD_WITH_X11)
    target_compile_definitions(dock-taskmanager PRIVATE BUILD_WITH_X11=)
    pkg_check_modules(TaskmanagerXcb REQUIRED IMPORTED_TARGET xcb xcb-res xcb-ewmh xcb-icccm)
    find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget)
    target_sources(dock-taskmanager PRIVATE
        x11preview.h
        x11preview.cpp
        x11preview.qrc
        x11utils.cpp
        x11utils.h
        x11window.cpp
        x11window.h
        x11windowmonitor.cpp
        x11windowmonitor.h
    )

    target_link_libraries(dock-taskmanager PUBLIC
        PkgConfig::TaskmanagerXcb
        Qt${QT_VERSION_MAJOR}::Widgets
        Dtk${DTK_VERSION_MAJOR}::Widget
    )
endif(BUILD_WITH_X11)

ds_install_package(PACKAGE org.deepin.ds.dock.taskmanager TARGET dock-taskmanager)
dtk_add_config_meta_files(APPID org.deepin.ds.dock FILES dconfig/org.deepin.ds.dock.taskmanager.json) # compat
dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES dconfig/org.deepin.ds.dock.taskmanager.json)
ds_handle_package_translation(PACKAGE org.deepin.ds.dock.taskmanager)

=== debian/changelog ===
dde-shell (1.99.36) unstable; urgency=medium

  * feat: introduce RoleGroupModel
  * refactor: update display mode icons and logic

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 15 May 2025 21:15:21 +0800

dde-shell (1.99.35) unstable; urgency=medium

  * chore: drop no longer existed translation resource 
  * chore: update copywriting of dock modes 
  * feat: Add animation for position switching to dock	
  * Update translations from Transifex

-- Wu Jiangyu <wujiangyu@uniontech.com>  Tue, 13 May 2025 17:20:000 +0800

dde-shell (1.99.34) unstable; urgency=medium

  * refactor: simplify notification action handling
  * fix: need request back when embed popup hidden
  * fix: prevent duplicate OSD actions for same type
  * fix: remove DSG_APP_ID from notification action
  * chore: release dde-shell 1.99.33

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 08 May 2025 17:41:17 +0800

dde-shell (1.99.33) unstable; urgency=medium

  * [skip CI] Translate org.deepin.ds.osd.default.ts in pl
  * [skip CI] Translate org.deepin.ds.notificationcenter.ts in pt_BR
  * fix: Fixed the issue that qCDebug does not output
  * fix: initialize dock color theme with default value
  * fix: adjust ui of title for notification
  * fix: [Font-size] The Font size can not change by dde-control-center. (#1105)

 -- YeShanShan <yeshanshan@uniontech.com>  Tue, 29 Apr 2025 14:39:30 +0800

dde-shell (1.99.32) UNRELEASED; urgency=medium

  * chore: missing some translations for notification (BUG-289337)
  * fix: compatibility with Qt 6.9+
  * fix: elements not aligned correctly when dock resize (BUG-312831)
  * fix: need update exclusion zone when screen was added or removed
    (BUG-306339)
  * fix: bluetooth still entered notificationcenter (BUG-311617)
  * fix: The icons residing on pannel move from the right side to the left side
    (BUG-309403)
  * fix: dnd does not disable to play sound for notification (BUG-310921)

 -- Wang Zichong <wangzichong@deepin.org>  Thu, 17 Apr 2025 17:46:00 +0800

dde-shell (1.99.31) UNRELEASED; urgency=medium

  * fix: dock plugin display blurred on 1.25 screen scale ratio
  * refactor: Remove `searchitem` module from dock

 -- zhaoyingzhen <zhaoyingzhen@uniontech.com>  Thu, 10 Apr 2025 17:36:25 +0800

dde-shell (1.99.30) UNRELEASED; urgency=medium

  * bump version to 1.99.30

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 27 Mar 2025 16:48:29 +0800

dde-shell (1.99.29) UNRELEASED; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#1064)
    Thanks to transifex-integration[bot]
  * feat: Receive close quick panel requests from plugins(Bug: 272277)
  * feat: adjust OSD ui according to v25
  * fix: shadow clipped for notification
  * fix: window preview blurry

 -- YeShanShan <yeshanshan@deepin.org>  Thu, 27 Mar 2025 16:48:29 +0800

dde-shell (1.99.28) UNRELEASED; urgency=medium

  * chore: update translation

 -- zhangkun <zhangkun2@uniontech.com>  Fri, 14 Mar 2025 11:07:05 +0800

dde-shell (1.99.27) UNRELEASED; urgency=medium

  * fix: task area might have incorrect height after resize in some cases
    (BUG: 303541, 303155)

 --  Wang Zichong <wangzichong@deepin.org>  Thu, 13 Mar 2025 15:13:00 +0800

dde-shell (1.99.26) UNRELEASED; urgency=medium

  * fix: num-lock can't enable

 -- YeShanShan <yeshanshan@deepin.org>  Wed, 12 Mar 2025 14:50:53 +0800

dde-shell (1.99.25) UNRELEASED; urgency=medium

  * chore: bump version to 1.99.25

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 06 Mar 2025 19:58:56 +0800

dde-shell (1.99.24) UNRELEASED; urgency=medium

  * chore: bump version to 1.99.24

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 28 Feb 2025 10:25:56 +0800

dde-shell (1.99.23) UNRELEASED; urgency=medium

  * chore: remove dcc-dock-plugin

 -- zhangkun <zhangkun2@uniontech.com>  Fri, 21 Feb 2025 18:17:08 +0800

dde-shell (1.99.22) UNRELEASED; urgency=medium

  * fix: record replaced notification to DB (Bug: 296235)
  * fix: Error with SmartHidden and KeepHidden modes of dock (Bug: 302819)
  * feat: drop to dock task icon to launch with uri (Bug: 275395)
  * fix: Staging notifications cannot disappear after timeout (Bug: 303331)
  * fix: Incorrect application layout menu display content (Bug: 289221, 286541, 286553)
  * fix: Notifications not displayed in the center cannot disappear after timeout (Bug: 303295)
  * fix: Staging notifications cannot disappear after timeout (Bug: 303331)
  * fix: Dragging an application will hide the dock (Bug: 289207, 289205)
  * fix: add offset to quick panel drag item to avoid cursor cover icon (Bug: 293867)
  * fix: The dock automatically hides
  * fix: item size not updated when taskbar item count was changed (Bug: 289225)
  * i18n: Updates for project Deepin Desktop Environment
 
 -- Wang Zichong <wangzichong@deepin.org>  Fri, 21 Feb 2025 13:42:00 +0800

dde-shell (1.99.21) UNRELEASED; urgency=medium

  * fix: update replace notification entity expired time(Bug: 296507)
  * fix: pinned application, notifications display order is incorrect(Bug: 299887)

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 14 Feb 2025 10:24:56 +0800

dde-shell (1.99.20) UNRELEASED; urgency=medium

  * feat: provide execs and isLingLong properties
  * fix: jittering when draggin quick action applet
  * feat: Add files generated by qdbusXML2cpp and DCONG2cpp

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 23 Jan 2025 17:35:43 +0800

dde-shell (1.99.19) UNRELEASED; urgency=medium

  * Temporary disable grand search icon for treeland
  * Fix access wild pointer in notification center

 -- Wang Zichong <wangzichong@deepin.org>  Tue, 14 Jan 2025 16:00:00 +0800

dde-shell (1.99.18) UNRELEASED; urgency=medium

  * fix: plugin docked into tray area (#1007)
  * fix: drop BoxShadow for Attention animation
  * chore: Add the qt6-wayland running dependency

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 09 Jan 2025 20:34:48 +0800

dde-shell (1.99.17) UNRELEASED; urgency=medium

  * UNRELEASED



=== debian/control ===
Source: dde-shell
Section: DDE
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat ( =12),
 cmake,
 systemd,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-base-dev-tools,
 qt6-tools-dev,
 qt6-wayland ( >=6.8.0-0deepin6),
 qt6-wayland-dev ( >=6.8.0-0deepin6),
 qt6-wayland-dev-tools,
 qt6-wayland-private-dev,
 wayland-protocols,
 treeland-protocols,
 libdtk6gui-dev,
 libdtk6core-bin,
 libdtk6core-dev,
 libdtk6widget-dev,
 libdtkcommon-dev,
 libxcb-ewmh-dev,
 libxcb-res0-dev,
 libxcb-util-dev,
 libxcb-icccm4-dev,
 libxcb1-dev,
 libxtst-dev,
 libgtest-dev,
 extra-cmake-modules,
 libqt6svg6,
 libdtk6declarative, qml6-module-qtquick-controls2-styles-chameleon, qt6-declarative-private-dev,
 libyaml-cpp-dev,
 qt6-l10n-tools, qt6-svg-dev, dde-tray-loader-dev (> 1.99.14),
 dde-application-manager-api (> 1.2.23)
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: libdde-shell
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: DDE Shell library
 DDE Shell is a plugin system that integrates plugins developed based on this plugin system into DDE.

Package: libdde-shell-dev
Architecture: any
Depends: ${misc:Depends}, libdde-shell( =${binary:Version}),
  qt6-base-dev, libdtk6core-dev, qt6-tools-dev, qt6-declarative-dev
Description: DDE Shell devel library
 DDE Shell is a plugin system that integrates plugins developed based on this plugin system into DDE.

Package: dde-shell
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdde-shell( =${binary:Version}),
  libqt6svg6, qml6-module-qt-labs-platform,
  libqt6sql6-sqlite,
  qt6-wayland ( >=6.8),
  qml6-module-qtquick-layouts, qml6-module-qtquick-window,
  libdtk6declarative, qml6-module-qtquick-controls2-styles-chameleon,
  qml6-module-qtquick-layouts, qml6-module-qtquick-window,
  qml6-module-qt-labs-platform, qml6-module-qt-labs-qmlmodels,
  dde-tray-loader (> 1.99.8)
Multi-Arch: same
Description: An wrapper for developed based on dde-shell plugin system

Package: dde-shell-example
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdde-shell( =${binary:Version}),
  qml6-module-qt-labs-platform
Multi-Arch: same
Description: DDE Shell example
 This package contains some plugins based on dde-shell plugin system.

Package: dde-control-center-dock
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: dde-dock-dcc-plugin
Replaces: dde-dock-dcc-plugin
Multi-Arch: same
Description: A dock plugin for dde-control-center

## dde-shell 2.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -54,6 +54,7 @@
 
 find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Concurrent Quick WaylandClient DBus LinguistTools Sql)
 find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui)
+find_package(ICU 74.2 REQUIRED COMPONENTS uc i18n io)
 find_package(WaylandProtocols REQUIRED)
 find_package(PkgConfig REQUIRED)

=== applets/dde-appearance/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

find_package(Dtk6 REQUIRED COMPONENTS Core Tools)
add_library(dde-appearance SHARED
    appearanceapplet.cpp
    appearanceapplet.h
)

target_link_libraries(dde-appearance PRIVATE
    dde-shell-frame
    Qt${QT_MAJOR_VERSION}::DBus
)

dtk_add_dbus_interface(DBusInterface org.deepin.dde.Appearance1.xml Appearance1)
target_sources(dde-appearance PUBLIC ${DBusInterface})

ds_install_package(PACKAGE org.deepin.ds.dde-appearance TARGET dde-appearance)

=== applets/dde-apps/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS DBus)
find_package(DDEApplicationManager REQUIRED)
find_package(yaml-cpp REQUIRED)

set_source_files_properties(
    ${DDE_APPLICATION_MANAGER_DBUS_API_DIR}/org.desktopspec.ApplicationManager1.Application.xml
    PROPERTIES  INCLUDE api/types/am.h
                CLASSNAME Application
)

set_source_files_properties(
    ${DDE_APPLICATION_MANAGER_DBUS_API_DIR}/org.desktopspec.ApplicationManager1.xml
    PROPERTIES  INCLUDE api/types/am.h
                CLASSNAME ApplicationManager
)

set_source_files_properties(
    ${DDE_APPLICATION_MANAGER_DBUS_API_DIR}/org.desktopspec.ObjectManager1.xml
    PROPERTIES  INCLUDE api/types/am.h
                CLASSNAME ObjectManager
)

qt_add_dbus_interfaces(
    DBUS_INTERFACES
    ${DDE_APPLICATION_MANAGER_DBUS_API_DIR}/org.desktopspec.ApplicationManager1.Application.xml
    ${DDE_APPLICATION_MANAGER_DBUS_API_DIR}/org.desktopspec.ApplicationManager1.xml
    ${DDE_APPLICATION_MANAGER_DBUS_API_DIR}/org.desktopspec.ObjectManager1.xml
)


add_library(dde-apps SHARED ${DBUS_INTERFACES}
    amappitem.cpp
    amappitem.h
    amappitemmodel.cpp
    amappitemmodel.h
    appgroup.cpp
    appgroup.h
    appgroupmanager.cpp
    appgroupmanager.h
    appitem.cpp
    appitem.h
    appitemmodel.cpp
    appitemmodel.h
    appsapplet.cpp
    appsapplet.h
    appsdockedhelper.cpp
    appsdockedhelper.h
    appslaunchtimes.cpp
    appslaunchtimes.h
    categoryutils.cpp
    categoryutils.h
    itemspage.cpp
    itemspage.h
)

target_link_libraries(dde-apps PRIVATE
    dde-shell-frame
    Qt${QT_VERSION_MAJOR}::Concurrent
    yaml-cpp
)

ds_install_package(PACKAGE org.deepin.ds.dde-apps TARGET dde-apps)
dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES configs/org.deepin.ds.dde-apps.json)

=== example/applet-widget-example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Widgets)
find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Widget)

add_library(ds-example-applet-widget SHARED
    exampleapplet.h
    exampleapplet.cpp
)

target_link_libraries(ds-example-applet-widget PRIVATE
    dde-shell-frame
    Qt${QT_VERSION_MAJOR}::Widgets
    Dtk${DTK_VERSION_MAJOR}::Widget
)

ds_install_package(PACKAGE org.deepin.ds.example.applet-widget TARGET ds-example-applet-widget)

=== example/drag-example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

ds_install_package(PACKAGE org.deepin.ds.example.drag)

=== panels/notification/center/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

qt_add_qml_module(notificationcenterpanel
    PLUGIN_TARGET notificationcenterpanelplugin
    URI org.deepin.ds.notificationcenter
    VERSION 1.0
    QML_FILES
        NotifyCenter.qml
        NotifyStaging.qml
        NotifyHeader.qml
        NotifyView.qml
        NotifyViewDelegate.qml
        NormalNotify.qml
        OverlapNotify.qml
        GroupNotify.qml
        NotifySetting.qml
        NotifySettingMenu.qml
        AnimationSettingButton.qml
        BoundingRectangle.qml
        DataPanel.qml
        NotifyHeaderTitleText.qml
    SOURCES
        notificationcenterpanel.h
        notificationcenterpanel.cpp
        notificationcenterproxy.h
        notificationcenterproxy.cpp
        notificationcenterdbusadaptor.h
        notificationcenterdbusadaptor.cpp
        notifyaccessor.h
        notifyaccessor.cpp
        notifymodel.h
        notifymodel.cpp
        notifyitem.h
        notifyitem.cpp
        notifystagingmodel.h
        notifystagingmodel.cpp
    OUTPUT_DIRECTORY
        ${PROJECT_BINARY_DIR}/plugins/org/deepin/ds/notificationcenter/
)

qt_add_resources(notificationcenterpanel "ds_notificationcenterpanel_icons"
    PREFIX "/dsg/built-in-icons"
    BASE "icons"
    FILES
        icons/clean-group.dci
        icons/clean-alone.dci
        icons/clean-all.dci
        icons/fold.dci
        icons/more.dci
)

target_link_libraries(notificationcenterpanel
    PRIVATE
        dde-shell-frame
        ds-notification-shared
        Qt${QT_VERSION_MAJOR}::Quick
        Qt${QT_VERSION_MAJOR}::DBus
)

install(TARGETS notificationcenterpanelplugin DESTINATION "${QML_INSTALL_DIR}/org/deepin/ds/notificationcenter/")
install(DIRECTORY "${PROJECT_BINARY_DIR}/plugins/org/deepin/ds/notificationcenter/" DESTINATION "${QML_INSTALL_DIR}/org/deepin/ds/notificationcenter/")

ds_install_package(PACKAGE org.deepin.ds.notificationcenter TARGET notificationcenterpanel)
ds_handle_package_translation(PACKAGE org.deepin.ds.notificationcenter)

=== panels/dock/tray/quickpanel/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

qt_add_qml_module(tray-quickpanel
    PLUGIN_TARGET tray-quickpanel
    URI "org.deepin.ds.dock.tray.quickpanel"
    VERSION "1.0"
    SOURCES
        quickpanelproxymodel.cpp
        quickpanelproxymodel.h
    QML_FILES
        QuickPanel.qml
        DragItem.qml
        PanelPluginPage.qml
        PanelTrayItem.qml
        PluginItem.qml
        QuickPanelModel.qml
        QuickPanelPage.qml
        SubPluginPage.qml
    OUTPUT_DIRECTORY
        "${PROJECT_BINARY_DIR}/plugins/org/deepin/ds/dock/tray/quickpanel"
)

target_link_libraries(tray-quickpanel PRIVATE
    Dtk${DTK_VERSION_MAJOR}::Core
)

=== panels/notification/osd/audio/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_library(osd-audio SHARED
    audioapplet.cpp
    audioapplet.h
)

target_link_libraries(osd-audio PRIVATE
    dde-shell-frame
    Qt${QT_MAJOR_VERSION}::DBus
)

ds_install_package(PACKAGE org.deepin.ds.osd.audio TARGET osd-audio)

=== panels/notification/osd/windoweffect/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_library(osd-windowEffect SHARED
    windoweffectapplet.cpp
    windoweffectapplet.h
)

target_link_libraries(osd-windowEffect PRIVATE
    dde-shell-frame
)

ds_install_package(PACKAGE org.deepin.ds.osd.windoweffect TARGET osd-windowEffect)
ds_handle_package_translation(PACKAGE org.deepin.ds.osd.windoweffect)

=== debian/changelog ===
dde-shell (2.0.1) unstable; urgency=medium

  * chore: remove invalid translation resources
  * i18n: Updates for project Deepin Desktop Environment (#1168)
  * fix: incorrect target ts file path in transifex.yaml
  * i18n: Updates for project Deepin Desktop Environment (#1167)
  * fix: add missing resource in .tx/transifex.yaml

 -- WuJiangYu <wujiangyu@uniontech.com>  Tue, 24 Jun 2025 10:40:41 +0800

dde-shell (2.0.0) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#1162)
  * chore: adjust dockedElements DConfig
  * feat: add smart hide when hide desktop.
  * i18n: Updates for project Deepin Desktop Environment (#1159)
  * chore: set libdde-shell.so SOVERSION to 1

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 19 Jun 2025 10:15:26 +0800

dde-shell (1.99.39) unstable; urgency=medium

  * chore: use ICU for relative datetime formatting
  * fix: layershell calcular in x11 emulation
  * fix: The tray application flashes an icon when opened
  * feat: add activeWindow D-Bus interface
  * chore: tweak role{group,combine}model

-- Wang Zichong <wangzichong@deepin.org>  Thu, 12 Jun 2025 19:12:00 +0800

dde-shell (1.99.38) unstable; urgency=medium

  * fix: The tray window panel automatically opens 
  * fix: just use one Dbus interface.
  * fix: update tanslation with Lock dock. 
  * feat: Lock the height of dock. 

-- Wu Jiangyu <wujiangyu@uniontech.com>  Thu, 05 Jun 2025 16:35:14 +0800

dde-shell (1.99.37) unstable; urgency=medium

  * fix: support string list in notification hints
  * fix: replace NumberAnimation with XAnimator in notification bubble
  * style: enhance OSD window visual effects
  * fix: remove redundant mode property in NotifyItemContent
  * chore: simplify window effect descriptions
  * fix: incorrectly removed window in AbstractWindowMonitor
  * fix: add missing winIconRole to DockCombineModel
  * fix: smart hide state not updated when window closed
  * i18n: Updates for project Deepin Desktop Environment (#1127)
  * refactor: prepare for combined model for taskmanager

 -- YeShanShan <yeshanshan@uniontech.com>  Wed, 28 May 2025 18:30:25 +0800

## dde-shell 2.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -52,11 +52,31 @@
 include(KDEClangFormat)
 include(KDEGitCommitHooks)
 
-find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Concurrent Quick WaylandClient DBus LinguistTools Sql)
+find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Concurrent Quick WaylandClient WaylandCompositor DBus LinguistTools Sql)
 find_package(Dtk${DTK_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui)
 find_package(ICU 74.2 REQUIRED COMPONENTS uc i18n io)
 find_package(WaylandProtocols REQUIRED)
 find_package(PkgConfig REQUIRED)
+
+try_compile(COMPILE_RESULT
+    ${CMAKE_CURRENT_BINARY_DIR}/try_compile_build
+    SOURCES ${CMAKE_SOURCE_DIR}/tests/check/qt_wayland_keyextension.cpp
+    LINK_LIBRARIES
+        Qt${QT_VERSION_MAJOR}::WaylandCompositorPrivate
+        Qt${QT_VERSION_MAJOR}::WaylandCompositor
+    COMPILE_DEFINITIONS 
+        -DQT_WAYLANDCOMPOSITOR_LIB
+        -DQT_WAYLANDCOMPOSITORPRIVATE_LIB
+        -DQT_WAYLANDCOMPOSITOR_IMPLEMENTATION
+    OUTPUT_VARIABLE compile_output
+)
+
+if(COMPILE_RESULT)
+    message(STATUS "Deepin Qt detected (try_compile success)")
+    add_definitions(-DUSE_DEEPIN_QT)
+else()
+    message(STATUS "Deepin Qt not detected")
+endif()
 
 add_subdirectory(frame)
 add_subdirectory(shell)

=== shell/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Widget REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Widgets Gui WaylandClient)
find_package(TreelandProtocols REQUIRED)
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET wayland-client)

if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

add_executable(dde-shell
    main.cpp
    appletloader.h
    appletloader.cpp
    shell.h
    shell.cpp
    treelandoutputwatcher.h
    treelandoutputwatcher.cpp
    dde-shell.qrc
    override_dtkdeclarative_qml.qrc
)

qt_generate_wayland_protocol_client_sources(dde-shell
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-output-manager-v1.xml
)

target_compile_definitions(dde-shell
PRIVATE
    DS_VERSION=${CMAKE_PROJECT_VERSION}
)

target_link_libraries(dde-shell PRIVATE
    dde-shell-frame
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::GuiPrivate
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::WaylandClient
    Dtk${DTK_VERSION_MAJOR}::Gui
    Dtk${DTK_VERSION_MAJOR}::Widget
    Qt${QT_VERSION_MAJOR}::DBus
    PkgConfig::WaylandClient
)

configure_file(${CMAKE_SOURCE_DIR}/misc/dde-shell-plugin@.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/dde-shell-plugin@.service
    @ONLY)
configure_file(${CMAKE_SOURCE_DIR}/misc/dde-shell@.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/dde-shell@.service
    @ONLY)

install(TARGETS dde-shell DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dde-shell@.service DESTINATION ${SYSTEMD_USER_UNIT_DIR})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/dde-shell-plugin@.service DESTINATION ${SYSTEMD_USER_UNIT_DIR})
dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES org.deepin.dde.shell.json)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

add_subdirectory(panels)

=== applets/dde-am/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_library(dde-am SHARED
    amapplet.cpp
    amapplet.h
)

target_link_libraries(dde-am PRIVATE
    dde-shell-frame
    Qt${QT_MAJOR_VERSION}::DBus
)

ds_install_package(PACKAGE org.deepin.ds.dde-am TARGET dde-am)

=== example/applet-example-data/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_library(ds-example-applet-data SHARED
    exampleapplet.h
    exampleapplet.cpp
)

target_link_libraries(ds-example-applet-data PRIVATE
    dde-shell-frame
)

ds_install_package(PACKAGE org.deepin.ds.example.applet-data TARGET ds-example-applet-data)

=== example/bridge-example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_library(shell-apps-bridge-example SHARED
    exampleappletitem.cpp
    exampleappletitem.h
)

target_link_libraries(shell-apps-bridge-example PRIVATE
    dde-shell-frame
)

ds_install_package(PACKAGE org.deepin.ds.example.bridge TARGET shell-apps-bridge-example)

=== example/layershell-example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_executable(layershell-example main.cpp qml.qrc)
target_link_libraries(layershell-example PRIVATE Qt::Gui Qt::Qml)

=== example/panel-example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_library(ds-panel-example SHARED
    examplepanel.cpp
    examplepanel.h
)

target_link_libraries(ds-panel-example PRIVATE
    dde-shell-frame
)

find_package(Dtk${DTK_VERSION_MAJOR}DConfig REQUIRED)

dtk_add_config_meta_files(APPID "org.deepin.dde.shell" FILES org.deepin.ds.example.json)

ds_install_package(PACKAGE org.deepin.ds.example TARGET ds-panel-example)

=== panels/dock/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

configure_file(environments.h.in environments.h @ONLY)

find_package(PkgConfig REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} COMPONENTS Core DBus Gui Qml WaylandCompositor Widgets WaylandClient)
find_package(DdeTrayLoader REQUIRED)
find_package(TreelandProtocols REQUIRED)
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET wayland-client)

file(
    GLOB dock_panel_sources
    constants.h
    dockabstractsettingsconfig.h
    dockdbusproxy.cpp
    dockdbusproxy.h
    dockiteminfo.cpp
    dockiteminfo.h
    dockpanel.cpp
    dockpanel.h
    docksettings.cpp
    docksettings.h
    dockhelper.h
    dockhelper.cpp
    waylanddockhelper.h
    waylanddockhelper.cpp
    loadtrayplugins.h
    loadtrayplugins.cpp
)

# Old dbus interface compatible
qt_add_dbus_adaptor(dock_panel_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/api/old/org.deepin.dde.dock1.xml
    dockdbusproxy.h
    dock::DockDBusProxy
    dockfrontadaptor
    DockFrontAdaptor
)
qt_add_dbus_adaptor(dock_panel_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/api/old/org.deepin.dde.daemon.Dock1.xml
    dockdbusproxy.h
    dock::DockDBusProxy
    dockdaemonadaptor
    DockDaemonAdaptor
)

# dock dbus api
qt_add_dbus_adaptor(dock_panel_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/api/dbus/org.deepin.ds.dock.xml
    dockpanel.h
    dock::DockPanel
    dockadaptor
    DockAdaptor
)

add_library(dockpanel SHARED
    ${dock_panel_sources}
)

qt_generate_wayland_protocol_client_sources(dockpanel
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-wallpaper-color-v1.xml
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-dde-shell-v1.xml
)

target_link_libraries(dockpanel PRIVATE
    PkgConfig::WaylandClient
    Qt${QT_VERSION_MAJOR}::WaylandClient
    Qt${QT_VERSION_MAJOR}::WaylandClientPrivate
    Qt${QT_VERSION_MAJOR}::Widgets
    dde-shell-frame
)

if (BUILD_WITH_X11)
    target_compile_definitions(dockpanel PRIVATE BUILD_WITH_X11=)
    pkg_check_modules(XCB REQUIRED IMPORTED_TARGET xcb xcb-aux xcb-res xcb-ewmh)
    target_sources(dockpanel PRIVATE
        x11dockhelper.h
        x11dockhelper.cpp
    )

    target_link_libraries(dockpanel PUBLIC
        PkgConfig::XCB
    )
endif(BUILD_WITH_X11)

ds_install_package(PACKAGE org.deepin.ds.dock TARGET dockpanel)
ds_handle_package_translation(PACKAGE org.deepin.ds.dock)

# sub plugins
add_subdirectory(showdesktop)
add_subdirectory(taskmanager)
add_subdirectory(tray)
add_subdirectory(multitaskview)

find_package(DdeControlCenter)

#add_subdirectory(appruntimeitem)

# dock qml element(include Dock.xx defines and DockCompositor)
file(
    GLOB plugin_sources
    constants.h
    # dockfilterproxymodel.cpp
    # dockfilterproxymodel.h
    pluginmanagerextension_p.h
    pluginmanagerextension.cpp
    pluginmanagerintegration_p.h
    pluginmanagerintegration.cpp
    dockpositioner.h
    dockpositioner.cpp
)

set_source_files_properties(DockCompositor.qml PROPERTIES
    QT_QML_SINGLETON_TYPE TRUE
)

set_source_files_properties(MenuHelper.qml PROPERTIES
    QT_QML_SINGLETON_TYPE TRUE
)

set_source_files_properties(DockPalette.qml PROPERTIES
    QT_QML_SINGLETON_TYPE TRUE
)

qt_policy(SET QTP0001 OLD)
qt_add_qml_module(dock-plugin
    PLUGIN_TARGET dock-plugin
    URI "org.deepin.ds.dock"
    VERSION "1.0"
    SHARED
    SOURCES ${plugin_sources}
    QML_FILES DockCompositor.qml OverflowContainer.qml MenuHelper.qml DockPalette.qml
    AppletItemButton.qml
    AppletItemBackground.qml
    OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/plugins/org/deepin/ds/dock/
)

qt_generate_wayland_protocol_server_sources(dock-plugin
    FILES
        ${DDE_TRAY_LOADER_PROTOCOL}
        ${WaylandProtocols_DATADIR}/staging/fractional-scale/fractional-scale-v1.xml
)

target_link_libraries(dock-plugin PUBLIC
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::WaylandCompositor
PRIVATE
    PkgConfig::WaylandClient
    Qt${QT_VERSION_MAJOR}::WaylandCompositorPrivate
    Qt${QT_VERSION_MAJOR}::GuiPrivate
)

target_include_directories(dock-plugin
    PUBLIC
    $<TARGET_PROPERTY:dde-shell-frame,INTERFACE_INCLUDE_DIRECTORIES>
)

install(TARGETS dock-plugin DESTINATION "${QML_INSTALL_DIR}/org/deepin/ds/dock/")
install(DIRECTORY "${PROJECT_BINARY_DIR}/plugins/org/deepin/ds/dock/" DESTINATION "${QML_INSTALL_DIR}/org/deepin/ds/dock/")
dtk_add_config_meta_files(APPID org.deepin.ds.dock FILES dconfig/org.deepin.ds.dock.json) # compat
dtk_add_config_meta_files(APPID org.deepin.ds.dock FILES dconfig/org.deepin.ds.dock.tray.json) # compat
dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES dconfig/org.deepin.ds.dock.json)
dtk_add_config_meta_files(APPID org.deepin.dde.shell FILES dconfig/org.deepin.ds.dock.tray.json)

=== panels/notification/CMakeLists.txt ===
--- 
+++ 
@@ -35,6 +35,9 @@
     Qt${QT_VERSION_MAJOR}::Core
     Qt${QT_VERSION_MAJOR}::Sql
     Dtk${DTK_VERSION_MAJOR}::Core
+    ICU::uc
+    ICU::i18n
+    ICU::io
 )
 
 install(TARGETS ds-notification-shared DESTINATION "${LIB_INSTALL_DIR}")

=== panels/dock/multitaskview/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

find_package(PkgConfig REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} COMPONENTS WaylandClient)
find_package(TreelandProtocols REQUIRED)
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET wayland-client)

add_library(dock-multitaskview SHARED
    multitaskview.cpp
    multitaskview.h
    treelandmultitaskview.cpp
    treelandmultitaskview.h
    ../dockiteminfo.cpp
    ../dockiteminfo.h
)

target_include_directories(dock-multitaskview PRIVATE
    "${CMAKE_CURRENT_BINARY_DIR}/../"
    "../"
)

qt_generate_wayland_protocol_client_sources(dock-multitaskview
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-dde-shell-v1.xml
)

target_link_libraries(dock-multitaskview PRIVATE
    PkgConfig::WaylandClient
    Qt${QT_VERSION_MAJOR}::WaylandClient
    dde-shell-frame
)

ds_install_package(PACKAGE org.deepin.ds.dock.multitaskview TARGET dock-multitaskview)
ds_handle_package_translation(PACKAGE org.deepin.ds.dock.multitaskview)

install(FILES "package/icons/dcc-view.dci" DESTINATION share/dde-dock/icons/dcc-setting RENAME dcc-multitasking-view.dci)

=== panels/dock/showdesktop/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

find_package(PkgConfig REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} ${REQUIRED_QT_VERSION} COMPONENTS WaylandClient)
find_package(TreelandProtocols REQUIRED)
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET wayland-client)

add_library(dock-showdesktop SHARED
    showdesktop.cpp
    showdesktop.h
    treelandwindowmanager.cpp
    treelandwindowmanager.h
)

qt_generate_wayland_protocol_client_sources(dock-showdesktop
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-window-management-v1.xml
)

target_link_libraries(dock-showdesktop PRIVATE
    dde-shell-frame
    Qt${QT_VERSION_MAJOR}::WaylandClient
    PkgConfig::WaylandClient
)

ds_install_package(PACKAGE org.deepin.ds.dock.showdesktop TARGET dock-showdesktop)
ds_handle_package_translation(PACKAGE org.deepin.ds.dock.showdesktop)

=== debian/changelog ===
dde-shell (2.0.3) unstable; urgency=medium

  * feat: enhance notification validation and cleanup
  * refactor: remove debug panel and legacy DBus code
  * refactor: update notification handling and data access logic
  * fix: sort notifications by timestamp before display
  * i18n: Updates for project Deepin Desktop Environment (#1174)
  * chore: reduce layershell emulate log message's log level

 -- WuJiangYu <wujiangyu@uniontech.com>  Thu, 10 Jul 2025 20:15:01 +0800

dde-shell (2.0.2) unstable; urgency=medium

  * fix: fix safe build.
  * fix: cannot build on Archlinux
  * fix: Fixed the blurriness of the preview window to separate the X11
    and wayland environments.
  * fix: fix launchpad fullsream, click dock ,it will not close.
  * fix: init showingDesktop for smart Hide.
  * feat: add preview follows the system opacity.
  * fix: modify when keep hiden animation has launched, has shadow and
    line.
  * fix: adapt import change of QtQml.Models in Qt 6.9
  * i18n: Updates for project Deepin Desktop Environment (#1172)
  * fix(tray): allow plugin icons to be dragged to leftmost position ﻿ -
    Fix overly strict drag condition in TrayContainer.qml that prevented
    plugin icons from being dragged to the leftmost position - Replace
    `dropHoverIndex !== 0` check with precise condition `dropHoverIndex
    === 0 && !surfaceId.startsWith("application-tray") && isBefore` -
    Maintain protection for application tray icons while allowing plugin
    icons to be properly positioned - Fix inconsistent behavior between
    animation states

 -- WuJiangYu <wujiangyu@uniontech.com>  Thu, 03 Jul 2025 16:32:57 +0800

=== debian/control ===
--- 
+++ 
@@ -21,6 +21,7 @@
  libdtk6core-dev,
  libdtk6widget-dev,
  libdtkcommon-dev,
+ libicu-dev,
  libxcb-ewmh-dev,
  libxcb-res0-dev,
  libxcb-util-dev,

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall
export DEB_CXXFLAGS_MAINT_APPEND = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E

DISTRO = $(shell lsb_release -is)
ifeq ($(DISTRO),Deepin)
	ENABLE_DEEPIN_NMQT=ON
else
	ENABLE_DEEPIN_NMQT=OFF
endif

VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
# Fix: invalid digit "8" in octal constant. e.g.  u008 ==> 008 ==> 8
BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DDS_VERSION=${PACK_VER} -DENABLE_DEEPIN_NMQT=${ENABLE_DEEPIN_NMQT}
